package zdb

import "github.com/georgysavva/scany/v2/pgxscan"

func (d *Pool) QGet(q pgxscan.Querier, dst any, sql string, args ...any) error {
	return pgxscan.Get(d.ctx, q, dst, sql, args...)
}

func (d *Pool) Get(dst any, sql string, args ...any) error {
	return d.execWrapper(ConnModeSync, dst, func(conn *conn, dst1 any) error {
		return d.QGet(conn, dst1, sql, args...)
	})
}

func (d *Pool) GetNamed(dst any, sql string, args map[string]any) error {
	return d.execWrapper(ConnModeSync, dst, func(conn *conn, dst1 any) error {
		return d.QGet(conn, dst1, d.prepare(sql, args))
	})
}

func (d *Pool) GetOpts(dst any, opts Opts) error {
	sql, args := opts.Opts()

	return d.execWrapper(ConnModeSync, dst, func(conn *conn, dst1 any) error {
		return d.QGet(conn, dst1, d.prepare(sql, args))
	})
}

func (d *Pool) GetAsync(dst any, sql string, args ...any) error {
	return d.execWrapper(ConnModeAsync, dst, func(conn *conn, dst1 any) error {
		return d.QGet(conn, dst1, sql, args...)
	})
}

func (d *Pool) GetAsyncNamed(dst any, sql string, args map[string]any) error {
	return d.execWrapper(ConnModeAsync, dst, func(conn *conn, dst1 any) error {
		return d.QGet(conn, dst1, d.prepare(sql, args))
	})
}

func (d *Pool) WGet(dst any, sql string, args ...any) error {
	return d.QGet(d.srvMaster, dst, sql, args...)
}

func (d *Pool) WGetNamed(dst any, sql string, args map[string]any) error {
	return d.QGet(d.srvMaster, dst, d.prepare(sql, args))
}
